//Dash v1.0 by Strathos
 
#include "MakeDustParticle.as";
#include "ActorHUDStartPos.as";
 
const u16 DASH_COOLDOWN=    6;//seconds*30
const u16 DASH_MAX=    		1; //max jumps (+1)
const f32 DASH_FORCE=   7.0;//force applied
 
void onInit(CBlob@ this)
{
	this.set_u8("dashCooldown",0);
	this.set_u8("dashesDone",0);
    this.getCurrentScript().removeIfTag=    "dead";
}
void onTick(CBlob@ this)
{
	u8 dashCooldown = this.get_u8("dashCooldown");
	u8 dashesDone=this.get_u8("dashesDone");
	bool onGround=	this.isOnGround() || this.isOnLadder();
	Vec2f aimPos=	this.getAimPos();
	Vec2f pos=		this.getPosition();
	Vec2f vel=		this.getVelocity();

	if(dashesDone<DASH_MAX && dashCooldown<=0)
	{
		if(((this.isKeyPressed(key_up) || this.isKeyPressed(key_down)) && onGround)||
		(this.isKeyPressed(key_up) && !this.wasKeyPressed(key_up))||
		(this.isKeyPressed(key_down) && !this.wasKeyPressed(key_down)))
		{
			this.set_u8("dashesDone",dashesDone+1);
			this.set_u8("dashCooldown",DASH_COOLDOWN);
			MakeDustParticle(pos+Vec2f(0.0f,9.0f),"/DustSmall.png");
			this.getSprite().PlaySound("/Ha_A.ogg");//StoneStep7.ogg,changed to custom HA sound
			Vec2f force=ActualNormalize(aimPos-pos)*DASH_FORCE;
			if((force.y>0 && this.isKeyPressed(key_up))||(force.y<=0 && this.isKeyPressed(key_down))){
				force.y*=-1;
			}
			if((force.x>0 && this.isKeyPressed(key_left)) || (force.x<0 && this.isKeyPressed(key_right))){
				force.x*=-1;
			}
			if(onGround){
				this.setVelocity(force);
			}else{
				this.setVelocity(Vec2f(force.x>0?Maths::Max(force.x,vel.x):Maths::Min(force.x,vel.x),force.y>0?Maths::Max(force.y,vel.y):Maths::Min(force.y,vel.y)));
			}
		}
	}
	else
	{
		if(onGround){
			this.set_u8("dashesDone",0);
		}
		if(dashCooldown>0){
			dashCooldown-=1;
			if(dashCooldown<=0){
				dashCooldown=0;
			}
			this.set_u8("dashCooldown",dashCooldown);
		}
	}
}
void onRender (CSprite@ this)
{
    CBlob@ blob=    this.getBlob();
    if(blob is null)
        return;
 
    Vec2f tl=   getActorHUDStartPosition(blob,6);
    float dashCooldown= blob.get_u8("dashCooldown");
    GUI::DrawProgressBar(tl,tl+Vec2f(160,35),1-(dashCooldown/DASH_COOLDOWN));
}
Vec2f ActualNormalize(Vec2f value)
{
    float dis=	Maths::Sqrt(value.x*value.x+value.y*value.y);
    return Vec2f(value.x/dis,value.y/dis);
}